#!/bin/bash

echo "[$(date +%T)] GET $1 ($2)" >> get.log

./handle_requests.sh $@
if [ $? -eq 0 ]; then
  exit 0
fi

if [ -z "$1" -o "$1" == "index.html" ]; then
  body="<html>\n<head>\n<title>$WAKEBOARD_TITLE</title>\n<script type='text/javascript' src='main.js'></script>\n<link rel='stylesheet' href='main.css'></link>\n</head>\n"
  body+="<body>\n<table>\n<tr><td></td><td>Hostname</td><td>IP Address</td><td>MAC Address</td><td>Wakeup</td></tr>\n"

  IFS=$'\n'
  leases=$(cat /var/lib/misc/dnsmasq.leases | cut -d ' ' -f2-4)
  for lease in $leases; do
    mac=$(echo $lease | cut -d ' ' -f1)
    ip=$(echo $lease | cut -d ' ' -f2)
    hostname=$(echo $lease | cut -d ' ' -f3)

    if [ -n "$(grep -i "$mac" /etc/dnsmasq.conf)" ]; then
      body+="<tr class='host' data-ip='$ip' data-mac='$mac'>\n"

      body+="<td class='status'>"
      body+="<div 'class='fail'>X</div>"
      body+="<div class='success' style='display: none;'>&#10003;</div>"
      body+="<div class='undef' style='display: none;'>?</div>"
      body+="</td>\n"

      body+="<td>$hostname</td>"
      body+="<td>$ip</td>"
      body+="<td>$mac</td>"
      body+="<td><button class='wol'>Wake up!</button><td>\n"
      body+="</tr>"
    fi
  done

  body+="</table>\n</body>\n</html>\n"

cat <<EOF
$($BASHSERV_DIR/header.sh -t "text/html" -l $(echo -ne "$body" | wc -c))
$(echo -ne $body)
EOF

  exit 0
fi

./handle_404.sh $@
exit $?
